diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/test/wifi-phy-cca-test.cc ns-3.47/src/wifi/test/wifi-phy-cca-test.cc
--- ns-3.46/src/wifi/test/wifi-phy-cca-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/test/wifi-phy-cca-test.cc	2026-02-16 16:08:49.882231000 -0800
@@ -52,22 +52,24 @@
 constexpr MHz_u P160_CENTER_FREQUENCY = P80_CENTER_FREQUENCY + MHz_u{40};
 constexpr MHz_u S160_CENTER_FREQUENCY = P160_CENTER_FREQUENCY + MHz_u{160};
 constexpr MHz_u P320_CENTER_FREQUENCY = P160_CENTER_FREQUENCY + MHz_u{80};
+const Time testStep = Seconds(1);
 const Time smallDelta = NanoSeconds(1);
 const Time aCcaTime = MicroSeconds(4);
-const Time phyHeaderDuration = MicroSeconds(32);
-// add small delta to be right after aCcaTime, since test checks are scheduled before wifi
-// events
+const Time legacyPhyHeaderDuration = MicroSeconds(20);
+const Time hePhyHeaderDuration = MicroSeconds(32);
+const Time ehtPhyHeaderDuration = MicroSeconds(40);
+// add small delta to be right after aCcaTime, since test checks are scheduled before wifi events
 const Time aCcaTimeWithDelta = aCcaTime + smallDelta;
 const std::map<MHz_u, Time> hePpduDurations = {
-    {20, NanoSeconds(1009600)},
-    {40, NanoSeconds(533600)},
-    {80, NanoSeconds(275200)},
+    {MHz_u{20}, NanoSeconds(1009600)},
+    {MHz_u{40}, NanoSeconds(533600)},
+    {MHz_u{80}, NanoSeconds(275200)},
 };
 const std::map<MHz_u, Time> ehtPpduDurations = {
-    {20, NanoSeconds(1017600)},
-    {40, NanoSeconds(541600)},
-    {80, NanoSeconds(287200)},
-    {160, NanoSeconds(178400)},
+    {MHz_u{20}, NanoSeconds(1017600)},
+    {MHz_u{40}, NanoSeconds(541600)},
+    {MHz_u{80}, NanoSeconds(287200)},
+    {MHz_u{160}, NanoSeconds(178400)},
 };
 
 /**
@@ -188,7 +190,7 @@
 WifiPhyCcaThresholdsTest::CreateDummyNonHtPpdu(const WifiPhyOperatingChannel& channel)
 {
     WifiTxVector txVector = WifiTxVector(OfdmPhy::GetOfdmRate6Mbps(),
-                                         0,
+                                         WIFI_MIN_TX_PWR_LEVEL,
                                          WIFI_PREAMBLE_LONG,
                                          NanoSeconds(800),
                                          1,
@@ -204,7 +206,7 @@
 WifiPhyCcaThresholdsTest::CreateDummyHtPpdu(MHz_u bandwidth, const WifiPhyOperatingChannel& channel)
 {
     WifiTxVector txVector = WifiTxVector(HtPhy::GetHtMcs0(),
-                                         0,
+                                         WIFI_MIN_TX_PWR_LEVEL,
                                          WIFI_PREAMBLE_HT_MF,
                                          NanoSeconds(800),
                                          1,
@@ -221,7 +223,7 @@
                                              const WifiPhyOperatingChannel& channel)
 {
     WifiTxVector txVector = WifiTxVector(VhtPhy::GetVhtMcs0(),
-                                         0,
+                                         WIFI_MIN_TX_PWR_LEVEL,
                                          WIFI_PREAMBLE_VHT_SU,
                                          NanoSeconds(800),
                                          1,
@@ -237,7 +239,7 @@
 WifiPhyCcaThresholdsTest::CreateDummyHePpdu(MHz_u bandwidth, const WifiPhyOperatingChannel& channel)
 {
     WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs0(),
-                                         0,
+                                         WIFI_MIN_TX_PWR_LEVEL,
                                          WIFI_PREAMBLE_HE_SU,
                                          NanoSeconds(800),
                                          1,
@@ -254,7 +256,7 @@
                                              const WifiPhyOperatingChannel& channel)
 {
     WifiTxVector txVector{EhtPhy::GetEhtMcs0(),
-                          0,
+                          WIFI_MIN_TX_PWR_LEVEL,
                           WIFI_PREAMBLE_EHT_MU,
                           NanoSeconds(800),
                           1,
@@ -717,7 +719,7 @@
     // EHT PHY: 160 MHz EHT PPDU in secondary160 channel (160 MHz) if power above the max
     // between the CCA sensitivity threshold for Per 20MHz check and the OBSS-PD level
     VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
-                       CreateDummyEhtPpdu(160, m_phy->GetOperatingChannel()),
+                       CreateDummyEhtPpdu(MHz_u{160}, m_phy->GetOperatingChannel()),
                        WIFI_CHANLIST_SECONDARY160,
                        std::max(m_obssPdLevel, m_per20CcaSensitivity));
 }
@@ -828,10 +830,16 @@
                             const std::vector<Time>& per20MhzDurations) override
     {
         NS_LOG_FUNCTION(this << duration << channelType << per20MhzDurations.size());
-        m_endCcaBusy = Simulator::Now() + duration;
+        NS_ASSERT(duration.IsPositive());
+        const auto now = Simulator::Now();
+        if (m_startCcaBusy.IsZero())
+        {
+            m_startCcaBusy = now;
+        }
+        m_endCcaBusy = now + duration;
         m_lastCcaBusyChannelType = channelType;
         m_lastPer20MhzCcaBusyDurations = per20MhzDurations;
-        m_notifications++;
+        ++m_notifications;
     }
 
     void NotifySwitchingStart(Time duration) override
@@ -860,13 +868,15 @@
     void Reset()
     {
         m_notifications = 0;
-        m_endCcaBusy = Seconds(0);
+        m_startCcaBusy = Time();
+        m_endCcaBusy = Time();
         m_lastCcaBusyChannelType = WIFI_CHANLIST_PRIMARY;
         m_lastPer20MhzCcaBusyDurations.clear();
     }
 
     std::size_t m_notifications{0}; ///< Number of CCA notifications
-    Time m_endCcaBusy{Seconds(0)};  ///< End of the CCA-BUSY duration
+    Time m_startCcaBusy{};          ///< Start of the CCA-BUSY duration
+    Time m_endCcaBusy{};            ///< End of the CCA-BUSY duration
     WifiChannelListType m_lastCcaBusyChannelType{
         WIFI_CHANLIST_PRIMARY}; ///< Channel type indication for the last CCA-BUSY notification
     std::vector<Time>
@@ -877,7 +887,13 @@
  * @ingroup wifi-test
  * @ingroup tests
  *
- * @brief Wifi Phy Threshold Test base class
+ * @brief Test CCA_BUSY indication provided by the PHY
+ *
+ * Many scenarios are being tested, where one or more PPDUs are being received and/or one or more
+ * (non-wifi) signals are being received. The tests verify the PHY states at different time
+ * points, and the CCA_BUSY indication at various point in time (amount of notifications, start and
+ * end of CCA_BUSY periods and per-20MHz bitmaps). The tests are run for all possible channel width
+ * and PPDU/signal widths combinations.
  */
 class WifiPhyCcaIndicationTest : public TestCase
 {
@@ -922,40 +938,59 @@
     void StopSignal(Ptr<WaveformGenerator> signalGenerator);
 
     /**
+     * Update the CCA threshold of the PHY
+     * @param ccaThreshold the new CCA threshold value to be set
+     */
+    void UpdateCcaThreshold(dBm_u ccaThreshold);
+
+    /**
      * Check the PHY state
+     * @param scenario the scenario under test
      * @param expectedState the expected state of the PHY
      */
-    void CheckPhyState(WifiPhyState expectedState);
+    void CheckPhyState(const std::string& scenario, WifiPhyState expectedState);
     /// @copydoc CheckPhyState
-    void DoCheckPhyState(WifiPhyState expectedState);
+    void DoCheckPhyState(const std::string& scenario, WifiPhyState expectedState);
 
     /**
-     * Check the last CCA-BUSY notification
+     * Check the CCA-BUSY notifications
+     * @param scenario the scenario under test
+     * @param expectedCcaNotifications the expected number of CCA_BUSY notifications
+     * @param expectedStartTime the expected CCA-BUSY start time
      * @param expectedEndTime the expected CCA-BUSY end time
      * @param expectedChannelType the expected channel type
      * @param expectedPer20MhzDurations the expected per-20 MHz CCA-BUSY durations
      */
-    void CheckLastCcaBusyNotification(Time expectedEndTime,
-                                      WifiChannelListType expectedChannelType,
-                                      const std::vector<Time>& expectedPer20MhzDurations);
-
+    void CheckCcaBusyNotifications(const std::string& scenario,
+                                   std::size_t expectedCcaNotifications,
+                                   Time expectedStartTime,
+                                   Time expectedEndTime,
+                                   WifiChannelListType expectedChannelType,
+                                   const std::vector<Time>& expectedPer20MhzDurations);
+    /// @copydoc CheckCcaBusyNotifications
+    void DoCheckCcaBusyNotifications(const std::string& scenario,
+                                     std::size_t expectedCcaNotifications,
+                                     Time expectedStartTime,
+                                     Time expectedEndTime,
+                                     WifiChannelListType expectedChannelType,
+                                     const std::vector<Time>& expectedPer20MhzDurations);
     /**
      * Log scenario description
      *
-     * @param log the scenario description to add to log
+     * @param scenario the scenario description to add to log
      */
-    void LogScenario(const std::string& log) const;
+    void LogScenario(const std::string& scenario) const;
 
     /**
      * structure that holds information to generate signals
      */
     struct TxSignalInfo
     {
-        dBm_u power{0.0};           //!< transmit power to use
-        Time startTime{Seconds(0)}; //!< time at which transmission will be started
-        Time duration{Seconds(0)};  //!< the duration of the transmission
-        MHz_u centerFreq{0};        //!< center frequency to use
-        MHz_u bandwidth{0};         //!< bandwidth to use
+        dBm_u power;      //!< transmit power to use
+        Time startTime;   //!< time at which transmission will be started
+        Time duration;    //!< the duration of the transmission
+        MHz_u centerFreq; //!< center frequency to use
+        MHz_u bandwidth;  //!< bandwidth to use
     };
 
     /**
@@ -963,10 +998,10 @@
      */
     struct TxPpduInfo
     {
-        dBm_u power{0.0};           //!< transmit power to use
-        Time startTime{Seconds(0)}; //!< time at which transmission will be started
-        MHz_u centerFreq{0};        //!< center frequency to use
-        MHz_u bandwidth{0};         //!< bandwidth to use
+        dBm_u power;      //!< transmit power to use
+        Time startTime;   //!< time at which transmission will be started
+        MHz_u centerFreq; //!< center frequency to use
+        MHz_u bandwidth;  //!< bandwidth to use
     };
 
     /**
@@ -974,7 +1009,7 @@
      */
     struct StateCheckPoint
     {
-        Time timePoint{Seconds(0)}; //!< time at which the check will performed
+        Time timePoint; //!< time at which the check will performed
         WifiPhyState expectedPhyState{WifiPhyState::IDLE}; //!< expected PHY state
     };
 
@@ -983,26 +1018,41 @@
      */
     struct CcaCheckPoint
     {
-        Time timePoint{Seconds(0)};          //!< time at which the check will performed
-        Time expectedCcaEndTime{Seconds(0)}; //!< expected CCA_BUSY end time
+        Time timePoint;                          //!< time at which the check will performed
+        std::size_t expectedCcaNotifications{0}; //!< expected number of CCA_BUSY notifications
+        Time expectedCcaStartTime;               //!< expected CCA_BUSY start time
+        Time expectedCcaEndTime;                 //!< expected CCA_BUSY end time
         WifiChannelListType expectedChannelListType{
-            WIFI_CHANLIST_PRIMARY};                    //!< expected channel list type
-        std::vector<Time> expectedPer20MhzDurations{}; //!< expected per-20 MHz CCA duration
+            WIFI_CHANLIST_PRIMARY};                  //!< expected channel list type
+        std::vector<Time> expectedPer20MhzDurations; //!< expected per-20 MHz CCA duration
+    };
+
+    /**
+     * structure that holds information to perform CCA threshold update
+     */
+    struct CcaThresholdUpdatePoint
+    {
+        Time timePoint;     //!< time at which the update will be performed
+        dBm_u ccaThreshold; //!< new CCA threshold value to be set
     };
 
     /**
      * Schedule test to perform.
      * @param delay the reference delay to schedule the events
+     * @param scenario description of the scenario to test
      * @param generatedSignals the vector of signals to be generated
      * @param generatedPpdus the vector of PPDUs to be generated
      * @param stateCheckpoints the vector of PHY state checks
      * @param ccaCheckpoints the vector of PHY CCA checks
+     * @param ccaThresholdUpdates the vector of CCA threshold updates
      */
     void ScheduleTest(Time delay,
+                      const std::string& scenario,
                       const std::vector<TxSignalInfo>& generatedSignals,
                       const std::vector<TxPpduInfo>& generatedPpdus,
                       const std::vector<StateCheckPoint>& stateCheckpoints,
-                      const std::vector<CcaCheckPoint>& ccaCheckpoints);
+                      const std::vector<CcaCheckPoint>& ccaCheckpoints,
+                      const std::vector<CcaThresholdUpdatePoint>& ccaThresholdUpdates = {});
 
     /**
      * Reset function
@@ -1022,7 +1072,7 @@
     WifiStandard m_standard; ///< The standard to use for the test
 
     Ptr<SpectrumWifiPhy> m_rxPhy; ///< PHY object of the receiver
-    Ptr<SpectrumWifiPhy> m_txPhy; ///< PHY object of the transmitter
+    Ptr<SpectrumWifiPhy> m_uxPhy; ///< PHY object of the transmitter
 
     std::vector<Ptr<WaveformGenerator>> m_signalGenerators; ///< Generators of non-wifi signals
     std::size_t m_numSignalGenerators; ///< The number of non-wifi signals generators needed for
@@ -1090,37 +1140,50 @@
     auto channelNum =
         WifiPhyOperatingChannel::FindFirst(0, frequency, bandwidth, m_standard, WIFI_PHY_BAND_6GHZ)
             ->number;
-    m_txPhy->SetOperatingChannel(
+    m_uxPhy->SetOperatingChannel(
         WifiPhy::ChannelTuple{channelNum, bandwidth, WIFI_PHY_BAND_6GHZ, 0});
 
     const auto mcs =
         (m_standard == WIFI_STANDARD_80211ax) ? HePhy::GetHeMcs0() : EhtPhy::GetEhtMcs0();
     const auto preamble =
         (m_standard == WIFI_STANDARD_80211ax) ? WIFI_PREAMBLE_HE_SU : WIFI_PREAMBLE_EHT_MU;
-    WifiTxVector txVector{mcs, 0, preamble, NanoSeconds(800), 1, 1, 0, bandwidth, false};
+    WifiTxVector
+        txVector{mcs, WIFI_MIN_TX_PWR_LEVEL, preamble, NanoSeconds(800), 1, 1, 0, bandwidth, false};
     Ptr<Packet> pkt = Create<Packet>(1000);
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_QOSDATA);
     hdr.SetQosTid(0);
     Ptr<WifiPsdu> psdu = Create<WifiPsdu>(pkt, hdr);
 
-    m_txPhy->SetTxPowerStart(txPower);
-    m_txPhy->SetTxPowerEnd(txPower);
+    m_uxPhy->SetTxPowerStart(txPower);
+    m_uxPhy->SetTxPowerEnd(txPower);
 
-    m_txPhy->Send(psdu, txVector);
+    m_uxPhy->Send(psdu, txVector);
+}
+
+void
+WifiPhyCcaIndicationTest::UpdateCcaThreshold(dBm_u ccaThreshold)
+{
+    NS_LOG_FUNCTION(this << ccaThreshold);
+    m_rxPhy->SetCcaEdThreshold(ccaThreshold);
 }
 
 void
-WifiPhyCcaIndicationTest::CheckPhyState(WifiPhyState expectedState)
+WifiPhyCcaIndicationTest::CheckPhyState(const std::string& scenario, WifiPhyState expectedState)
 {
+    NS_LOG_FUNCTION(this << expectedState);
     // This is needed to make sure PHY state will be checked as the last event if a state change
     // occurred at the exact same time as the check
-    Simulator::ScheduleNow(&WifiPhyCcaIndicationTest::DoCheckPhyState, this, expectedState);
+    Simulator::ScheduleNow(&WifiPhyCcaIndicationTest::DoCheckPhyState,
+                           this,
+                           scenario,
+                           expectedState);
 }
 
 void
-WifiPhyCcaIndicationTest::DoCheckPhyState(WifiPhyState expectedState)
+WifiPhyCcaIndicationTest::DoCheckPhyState(const std::string& scenario, WifiPhyState expectedState)
 {
+    NS_LOG_FUNCTION(this << expectedState);
     WifiPhyState currentState;
     PointerValue ptr;
     m_rxPhy->GetAttribute("State", ptr);
@@ -1129,52 +1192,116 @@
     NS_TEST_ASSERT_MSG_EQ(currentState,
                           expectedState,
                           "PHY State " << currentState << " does not match expected state "
-                                       << expectedState << " at " << Simulator::Now());
+                                       << expectedState << " at " << Simulator::Now()
+                                       << " for scenario: " << scenario << " (bw=" << m_channelWidth
+                                       << ")");
+}
+
+void
+WifiPhyCcaIndicationTest::CheckCcaBusyNotifications(
+    const std::string& scenario,
+    std::size_t expectedCcaNotifications,
+    Time expectedStartTime,
+    Time expectedEndTime,
+    WifiChannelListType expectedChannelType,
+    const std::vector<Time>& expectedPer20MhzDurations)
+{
+    Simulator::ScheduleNow(&WifiPhyCcaIndicationTest::DoCheckCcaBusyNotifications,
+                           this,
+                           scenario,
+                           expectedCcaNotifications,
+                           expectedStartTime,
+                           expectedEndTime,
+                           expectedChannelType,
+                           expectedPer20MhzDurations);
 }
 
 void
-WifiPhyCcaIndicationTest::CheckLastCcaBusyNotification(
+WifiPhyCcaIndicationTest::DoCheckCcaBusyNotifications(
+    const std::string& scenario,
+    std::size_t expectedCcaNotifications,
+    Time expectedStartTime,
     Time expectedEndTime,
     WifiChannelListType expectedChannelType,
     const std::vector<Time>& expectedPer20MhzDurations)
 {
+    auto printPer20Bitmap = [](const std::vector<Time>& v) -> std::string {
+        if (v.empty())
+        {
+            return "";
+        }
+        std::stringstream ss;
+        for (const auto& t : v)
+        {
+            ss << t << " ";
+        }
+        return ss.str();
+    };
+    NS_LOG_FUNCTION(this << expectedCcaNotifications << expectedStartTime << expectedEndTime
+                         << expectedChannelType << printPer20Bitmap(expectedPer20MhzDurations));
+    NS_TEST_ASSERT_MSG_EQ(m_rxPhyStateListener->m_notifications,
+                          expectedCcaNotifications,
+                          "Number of CCA busy notifications "
+                              << m_rxPhyStateListener->m_notifications
+                              << " does not match expected number " << expectedCcaNotifications
+                              << " at " << Simulator::Now() << " for scenario: " << scenario
+                              << " (bw=" << m_channelWidth << ")");
+    NS_TEST_ASSERT_MSG_EQ(m_rxPhyStateListener->m_startCcaBusy,
+                          expectedStartTime,
+                          "PHY CCA start time " << m_rxPhyStateListener->m_startCcaBusy
+                                                << " does not match expected time "
+                                                << expectedStartTime << " at " << Simulator::Now()
+                                                << " for scenario: " << scenario
+                                                << " (bw=" << m_channelWidth << ")");
     NS_TEST_ASSERT_MSG_EQ(m_rxPhyStateListener->m_endCcaBusy,
                           expectedEndTime,
                           "PHY CCA end time " << m_rxPhyStateListener->m_endCcaBusy
                                               << " does not match expected time " << expectedEndTime
-                                              << " at " << Simulator::Now());
+                                              << " at " << Simulator::Now() << " for scenario: "
+                                              << scenario << " (bw=" << m_channelWidth << ")");
     NS_TEST_ASSERT_MSG_EQ(m_rxPhyStateListener->m_lastCcaBusyChannelType,
                           expectedChannelType,
                           "PHY CCA-BUSY for " << m_rxPhyStateListener->m_lastCcaBusyChannelType
                                               << " does not match expected channel type "
-                                              << expectedChannelType << " at " << Simulator::Now());
+                                              << expectedChannelType << " at " << Simulator::Now()
+                                              << " for scenario: " << scenario
+                                              << " (bw=" << m_channelWidth << ")");
     NS_TEST_ASSERT_MSG_EQ(m_rxPhyStateListener->m_lastPer20MhzCcaBusyDurations.size(),
                           expectedPer20MhzDurations.size(),
                           "PHY CCA-BUSY per-20 MHz durations does not match expected vector"
-                              << " at " << Simulator::Now());
+                              << " at " << Simulator::Now() << " for scenario: " << scenario
+                              << " (bw=" << m_channelWidth << ")");
     for (std::size_t i = 0; i < expectedPer20MhzDurations.size(); ++i)
     {
         NS_TEST_ASSERT_MSG_EQ(m_rxPhyStateListener->m_lastPer20MhzCcaBusyDurations.at(i),
                               expectedPer20MhzDurations.at(i),
                               "PHY CCA-BUSY per-20 MHz duration at index "
                                   << i << " does not match expected duration at "
-                                  << Simulator::Now());
+                                  << Simulator::Now() << " for scenario: " << scenario
+                                  << " (bw=" << m_channelWidth << ")");
     }
 }
 
 void
-WifiPhyCcaIndicationTest::LogScenario(const std::string& log) const
+WifiPhyCcaIndicationTest::LogScenario(const std::string& scenario) const
 {
-    NS_LOG_INFO(log);
+    NS_LOG_INFO(scenario);
 }
 
 void
-WifiPhyCcaIndicationTest::ScheduleTest(Time delay,
-                                       const std::vector<TxSignalInfo>& generatedSignals,
-                                       const std::vector<TxPpduInfo>& generatedPpdus,
-                                       const std::vector<StateCheckPoint>& stateCheckpoints,
-                                       const std::vector<CcaCheckPoint>& ccaCheckpoints)
+WifiPhyCcaIndicationTest::ScheduleTest(
+    Time delay,
+    const std::string& scenario,
+    const std::vector<TxSignalInfo>& generatedSignals,
+    const std::vector<TxPpduInfo>& generatedPpdus,
+    const std::vector<StateCheckPoint>& stateCheckpoints,
+    const std::vector<CcaCheckPoint>& ccaCheckpoints,
+    const std::vector<CcaThresholdUpdatePoint>& ccaThresholdUpdates)
 {
+    Simulator::Schedule(delay, &WifiPhyCcaIndicationTest::LogScenario, this, scenario);
+
+    Simulator::Schedule(delay, &WifiPhyCcaIndicationTest::Reset, this);
+
     for (const auto& generatedPpdu : generatedPpdus)
     {
         Simulator::Schedule(delay + generatedPpdu.startTime,
@@ -1198,14 +1325,32 @@
                             generatedSignal.duration);
     }
 
-    for (const auto& checkpoint : ccaCheckpoints)
+    if (ccaCheckpoints.empty())
     {
-        Simulator::Schedule(delay + checkpoint.timePoint,
-                            &WifiPhyCcaIndicationTest::CheckLastCcaBusyNotification,
+        Simulator::Schedule(delay + (testStep / 2),
+                            &WifiPhyCcaIndicationTest::CheckCcaBusyNotifications,
                             this,
-                            Simulator::Now() + delay + checkpoint.expectedCcaEndTime,
-                            checkpoint.expectedChannelListType,
-                            checkpoint.expectedPer20MhzDurations);
+                            scenario,
+                            0,
+                            Time(),
+                            Time(),
+                            WIFI_CHANLIST_PRIMARY,
+                            std::vector<Time>{});
+    }
+    else
+    {
+        for (const auto& checkpoint : ccaCheckpoints)
+        {
+            Simulator::Schedule(delay + checkpoint.timePoint,
+                                &WifiPhyCcaIndicationTest::CheckCcaBusyNotifications,
+                                this,
+                                scenario,
+                                checkpoint.expectedCcaNotifications,
+                                Simulator::Now() + delay + checkpoint.expectedCcaStartTime,
+                                Simulator::Now() + delay + checkpoint.expectedCcaEndTime,
+                                checkpoint.expectedChannelListType,
+                                checkpoint.expectedPer20MhzDurations);
+        }
     }
 
     for (const auto& checkpoint : stateCheckpoints)
@@ -1213,16 +1358,26 @@
         Simulator::Schedule(delay + checkpoint.timePoint,
                             &WifiPhyCcaIndicationTest::CheckPhyState,
                             this,
+                            scenario,
                             checkpoint.expectedPhyState);
     }
 
-    Simulator::Schedule(delay + Seconds(0.5), &WifiPhyCcaIndicationTest::Reset, this);
+    for (const auto& ccaThresholdUpdate : ccaThresholdUpdates)
+    {
+        Simulator::Schedule(delay + ccaThresholdUpdate.timePoint,
+                            &WifiPhyCcaIndicationTest::UpdateCcaThreshold,
+                            this,
+                            ccaThresholdUpdate.ccaThreshold);
+    }
 }
 
 void
 WifiPhyCcaIndicationTest::Reset()
 {
+    NS_LOG_FUNCTION(this);
+    m_rxPhy->ConfigureStandard(m_standard); // make sure to clear PHY states
     m_rxPhyStateListener->Reset();
+    UpdateCcaThreshold(dBm_u{-62}); // restore default CCA threshold
 }
 
 void
@@ -1322,7 +1477,7 @@
 WifiPhyCcaIndicationTest::DoSetup()
 {
     // WifiHelper::EnableLogComponents ();
-    // LogComponentEnable ("WifiPhyCcaTest", LOG_LEVEL_ALL);
+    // LogComponentEnable("WifiPhyCcaTest", LOG_LEVEL_ALL);
 
     Ptr<MultiModelSpectrumChannel> spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
 
@@ -1354,16 +1509,16 @@
 
     Ptr<Node> txNode = CreateObject<Node>();
     Ptr<WifiNetDevice> txDev = CreateObject<WifiNetDevice>();
-    m_txPhy = CreateObject<SpectrumWifiPhy>();
-    m_txPhy->SetAttribute("ChannelSwitchDelay", TimeValue(Seconds(0)));
+    m_uxPhy = CreateObject<SpectrumWifiPhy>();
+    m_uxPhy->SetAttribute("ChannelSwitchDelay", TimeValue(Seconds(0)));
     Ptr<InterferenceHelper> txInterferenceHelper = CreateObject<InterferenceHelper>();
-    m_txPhy->SetInterferenceHelper(txInterferenceHelper);
+    m_uxPhy->SetInterferenceHelper(txInterferenceHelper);
     Ptr<ErrorRateModel> txErrorModel = CreateObject<NistErrorRateModel>();
-    m_txPhy->SetErrorRateModel(txErrorModel);
-    m_txPhy->AddChannel(spectrumChannel);
-    m_txPhy->ConfigureStandard(m_standard);
-    m_txPhy->SetDevice(txDev);
-    txDev->SetPhy(m_txPhy);
+    m_uxPhy->SetErrorRateModel(txErrorModel);
+    m_uxPhy->AddChannel(spectrumChannel);
+    m_uxPhy->ConfigureStandard(m_standard);
+    m_uxPhy->SetDevice(txDev);
+    txDev->SetPhy(m_uxPhy);
     txNode->AddDevice(txDev);
 
     for (std::size_t i = 0; i < m_numSignalGenerators; ++i)
@@ -1387,7 +1542,7 @@
     RngSeedManager::SetRun(1);
     int64_t streamNumber = 0;
     m_rxPhy->AssignStreams(streamNumber);
-    m_txPhy->AssignStreams(streamNumber);
+    m_uxPhy->AssignStreams(streamNumber);
 
     auto channelNum = WifiPhyOperatingChannel::FindFirst(0,
                                                          m_frequency,
